	   #include<reg51.h>   //Define 8051 Registers
 
void serial(void); //Serial Communication Register
void DelayMs(unsigned int);    //Delay Function
 
unsigned int i,j;
unsigned char b[25],d;
 
//---------------------------
//           Main Program
//---------------------------
void main()
{
    EA=1;            //Enable All Interrupt
    ES=1;            //Enable Serial Port Interrupt
    serial();        //Serial Communication
         while(1);    //Loop Forever
}
 
//------------------------------------------
//       Serial Communication Register Initialisation
//------------------------------------------
void serial(void)
{
    TMOD=0X20;       //Timer1, Mode2
    SCON=0X50;       //Serial Mode1, Receive Enable
    TH1=0XFD;        //Baud Rate 9600bps
    TR1=1;           //Timer1 ON
}
 
 
//-----------------------------------------
//       Serial Interrupt Function
//-----------------------------------------
void serin (void) interrupt 4  //Serial Port Interrupt
{
    if(RI==1) //Receive Interrupt Gets Enabled
    {            //after Stop Bit get Received
         d=SBUF; //Serial Buffer value moved to a variable
         b[j]=d;                                                     
         SBUF=b[j];
         DelayMs(20); //Delay Function
         j++;
    }
    SCON=0X50;   //Initialising Receive and Transmit Interrupt
}

 
//---------------------------------
//               Delay Function
//---------------------------------
void DelayMs(unsigned int k)
{
    unsigned int i;
    for(i=0;i<=k;i++);
}
 